/*
 * Ooga Booga!  a Y2Kode entry
 *
 * by Kaneda
 *
 * TECHNICAL NOTE
 * A Plan Adr = c000
 * window adr = b000
 * B Plan adr = e000
 * sprite adr = be00 (c000 - be00 = 0200 => 64 sprites max )
 * HScrol adr = b800
 *
 *
 * HISTORY
 * Revx.x       21Nov00
 * Rev0.0	20Dec00
 *			Enemy sprites walk/fly
 * Rev0.1	22Dec00
 *			Sprites Collision make damages to Hero!
 * Rev0.2	25Dec00
 *			Window show life status
 * Rev0.3	08Feb01
 *			Reset ( bad way but i can't make a JMP($0) )
 *			Sound
 * Rev0.4	19Feb01
 *			Logo & Start Screen
 * Rev0.41	22Feb01
 *			Sprites positions now correct!
 *			Level redone
 * Rev0.42	23Feb01
 *			Tiles contact optimized (no more slow down when tiles is inactif but different of 0)
 *			A good item and a VERY bad item
 *
 *
 *
 * Note on revision number
 * x.ab		x change when it's a new game, very different of previous one
 *		a change when there is a major improvment which asked a REALLY work (new feature, optimization by rewriting)
 *		b change when there is a minor improvment (bug fix, optimization by correction)
 *
 *		I don't think you'll see a beta/alpha/... version since it's not my way to release a version where i changed 1 by 0 :)
 */
  
 

/* Include files may not be nested more than 8 deep !!!	*/
/* So, include files DON'T include other file !!!	*/

/* #include "genesis.h" */
#include "all.h"
#include "fmmusic.h"


#include "chan2.src"
#include "chan4.src"

char _6_TEASE[] = {
0x0D, 0x3F, 0x00, 0x1F, 0x00, 0x0F, 0x00, 0x0A, 
0x08, 0x63, 0x00, 0x1F, 0x00, 0x0F, 0x00, 0x0A, 
0x0D, 0x5E, 0x00, 0x1F, 0x00, 0x0F, 0x00, 0x0A, 
0x04, 0x63, 0x00, 0x1F, 0x00, 0x0F, 0x00, 0x0A, 
0x06, 0x007};


char MONO_BAS[] = {
0x00, 0x3F, 0x00, 0x1F, 0x0D, 0x04, 0x19, 0x08, 
0x00, 0x3C, 0x01, 0x1F, 0x09, 0x00, 0x00, 0x08, 
0x00, 0x51, 0x01, 0x1F, 0x0A, 0x0B, 0x0F, 0x08, 
0x00, 0x63, 0x01, 0x1F, 0x08, 0x00, 0x00, 0x08, 
0x03, 0x006};


uchar ResetState;


/*************    Variables  *************/



/*************  Main program  ***********/
/* Init, start-logos & infinite loop	*/
/****************************************/
void main()
{
    Init_GFX();
    RAZ();       
   Logo_LinkSang();  

    Logo_y2kode();
    TransHour(BPLAN, 32 * y2k0_HSize*y2k0_VSize);

    MyLogo();
    
    while(1)
    {
        Menu();
        Level1_Op();
        Game();
        Level1_Ed();
    }
        
};





/**************  Menu sub-program  **************/
/* Menu screen   				*/
/* At this time, only wait for START :)		*/
/************************************************/
void Menu()
{

    register uint joy;
    register uint x, y, tmp;
    uint Tile;
    uint pal_tmp[16];
    uint AdrRef, AdrRef2;
        
    /* text */
    dma_vram_copy(tiledata, 0, 32*96);
    
    Tile = 96;
    /* our name logo */
    dma_vram_copy(menu0, 32*96, 32 * menu0_HSize*menu0_VSize);
    dma_vram_copy(menu1,  32*96 + 32 * menu0_HSize*menu0_VSize, 32 * menu1_HSize*menu1_VSize);

    AdrRef = 32*96 + 32 * menu0_HSize*menu0_VSize+ 32 * menu1_HSize*menu1_VSize;
    dma_vram_copy(shaolin0, AdrRef, 32 * shaolin0_HSize*shaolin0_VSize);
    dma_vram_copy(shaolin1, AdrRef + 32 * shaolin0_HSize*shaolin0_VSize, 32 * shaolin1_HSize*shaolin1_VSize);
    
    AdrRef2 = AdrRef + 32 * shaolin0_HSize*shaolin0_VSize + 32 * shaolin1_HSize*shaolin1_VSize;
    dma_vram_copy(mosquito0, AdrRef2, 32 * mosquito0_HSize*mosquito0_VSize);
    dma_vram_copy(fish0a, AdrRef2 + 32 * mosquito0_HSize*mosquito0_VSize, 32 * fish0a_HSize*fish0a_VSize);
    dma_vram_copy(fish0b, AdrRef2 + 32 * mosquito0_HSize*mosquito0_VSize + 32 * fish0a_HSize*fish0a_VSize, 32 * fish0b_HSize*fish0b_VSize);
    
    
    tmp = (32-menu0_HSize)/2;
    for (y=0; y< menu0_VSize; y++)
    {        
        for (x=tmp;x < menu0_HSize + tmp; x++)
        {
        	show_tiles( Tile, Tile, 0, x, y, BPLAN, 0, 0, 0);
        	Tile++;
       	}
    }

    tmp = (32-menu1_HSize)/2;
    for (; y< menu0_VSize+menu1_VSize; y++)
    {        
        for (x=tmp;x < menu1_HSize + tmp; x++)
        {
        	show_tiles( Tile, Tile, 0, x, y, BPLAN, 0, 0, 0);
        	Tile++;
       	}
    }


    
    gotoxy(7, 21);
    outtext_xy("PRESS START BUTTON", 0, APLAN);
    gotoxy(7, 26);
    outtext_xy("(C) 2001 - KANEDA", 0, APLAN);
    gotoxy(6, 27);
    outtext_xy("GFX (C) ARI FELDMAN", 0, APLAN);

    /* Show Mick */
    def_sprite(1, 14*8, 14*8   , 0xf00, 0x2000 + (AdrRef / 32) ); 
    def_sprite(2, 14*8, 14*8+32, 0xc00, 0x2000 + (16 + AdrRef / 32));
    
    /* Show Fish */
    def_sprite(3, 7*8, 14*8   , 0xb00, 0x4000 + ((AdrRef2 + 32 * mosquito0_HSize*mosquito0_VSize) / 32) ); 
    def_sprite(4, 7*8, 14*8+32, 0x800, 0x4000 + ((AdrRef2 + 32 * mosquito0_HSize*mosquito0_VSize + 32 * fish0a_HSize*fish0a_VSize) / 32) );

    /* Show Mosquito */
    def_sprite(5, 21*8, 14*8  , 0xe00, 0x4000 + (AdrRef2 / 32) );

    fade(pal_black, pal_menu, 0, 2);
    
/*    set_colors(0, pal_menu); */
    set_colors(1, pal_shaolin); 
    set_colors(2, pal_enemy);

    show_sprite(1, 5);
    wait_sync();    

    init_joypad();
    tmp = 0;
    
    while (1)
    {

	joy= read_joypad1();
    	if (joy)
    	{
	       	switch(joy & 0xff)
	       	{
	       		case BUTTON_S:
	       			RAZ();
	       			return;
	       			break;
	       		default:
	       			break;
	       	}
	 }
	 
	gotoxy(7, 21);

	if (tmp++<25)
	 	outtext_xy("PRESS START BUTTON", 0, APLAN);
	else
	 	outtext_xy("                  ", 0, APLAN);

	if (tmp==40)	 tmp=0;
	wait_sync();
	
    }
}



/***************  Level 1 Opening  **************/
/* Show Level 1 title/name			*/
/************************************************/
void Level1_Op()
{
    gotoxy(6, 10);
    outtext_xy("LEVEL 1", 0, APLAN);

    gotoxy(9, 15);
    outtext_xy("JUST THE BEGINNING", 0, APLAN);

    
    fade(pal_black, pal_menu, 0, 2);    
    /*set_colors(0, pal_menu); */
    Wait(180);
    
    fade(pal_menu, pal_black, 0, 2);
    RAZ();
}	
	



/**************  Game sub-program  **************/
/* The MAIN loop   				*/
/************************************************/
void Game()
{
    register uint *pw;
    register uint x;




    /* Draw ALL */
     pw = (uint *) GFXCNTL;
    *pw = 0x9180;   /* reg 17 - window hpos (from left to 16 (0x10) div (1 div = 2 tiles in 32 cell modes) )*/
    *pw = 0x9203;   /* reg 18 - window vpos ( from top to 2 div (1div = 1tile) )*/

    
    LoadTile_Map();
    LoadTile_Object();
    LoadTile_Hero();
		
    Init_Map();    
    Init_Object();
    Init_Hero(&Mick);
        
    init_joypad();
    
    cPaused = 0;
    cInteractif = 1;

    AnimText = 0;

    LevelEnd = 0;
    while(1)
    {	
	if (cInteractif)	Test_Joy();
	if (!cPaused)
	{		
		Redraw();
		RedrawActifSpr();
		ShowText();	/* my little ad :) */
		/* all redrawn, now test sprite collision */
		if (Mick.Action != DIE)		SpritesContact(&Mick);
		ShowLife(&Mick);
	}
	if (LevelEnd)
	{
		cInteractif = 0;
		Mick.Action = WALK;
		Mick.Dir = RIGHT;
                Mick.Speed = WALK;                      
		for (x=1; x < (32*8); x++)
		{
			Mick.PosX++;
			Mick.Step++;
			DrawStep_Hero(&Mick);
			show_sprite(1,2);
			wait_sync();
		}			
		pw = (uint *) GFXCNTL;
	    	*pw = 0x9100;   /* reg 17 - window hpos */
		*pw = 0x92ff;   /* reg 18 - window vpos */

		RAZ();
		return;
	}
    }	
}



/***************  Level 1 Ending  ***************/
/* Show Level 1 end text			*/
/************************************************/
void Level1_Ed()
{
    register uint joy;
    register uint *pw;
    register ulong *pl;
    uint i, j, signe;
    
    /* text */
    dma_vram_copy(tiledata, 0, 32*96);

    init_synth();
    load_voice(CHAN2,_6_TEASE);
    load_voice(CHAN4,MONO_BAS);

    init_song_player();
    
    start_song(CHAN2,0,song_track2);
    start_song(CHAN4,0,song_track4);

    pw = (uint *) GFXCNTL;
    *pw = 0x8b02;   /* reg 11 - scroll H by cell */

/*  outtext_xy("12345678901234567890123456789012", 0, APLAN); */

/*
    gotoxy(1, 2);
    outtext_xy("THIS IS MY LITTLE DEMO FOR THE", 0, APLAN);
    gotoxy(1, 3);
    outtext_xy("Y2KODE COMPETITION.", 0, APLAN);

    gotoxy(1, 5);
    outtext_xy("IT'S FAR FROM A COMMERCIAL", 0, APLAN);
    gotoxy(1, 6);
    outtext_xy("GAME BUT I'M PROUD OF IT", 0, APLAN);
    gotoxy(1, 7);
    outtext_xy("SINCE IT'S MY FIRST FULL DEMO", 0, APLAN);
    gotoxy(1, 8);
    outtext_xy("I MADE 'ALONE'!      ", 0, APLAN);
    
    gotoxy(1, 10);
    outtext_xy("THANKS TO PAUL LEE", 0, APLAN);
    gotoxy(1, 11);
    outtext_xy("       SGCC COMPILER & SUPPORT", 0, APLAN);

    gotoxy(1, 13);
    outtext_xy("THANKS TO LENNART STEINKE", 0, APLAN);
    gotoxy(1, 14);
    outtext_xy("                     MAP MAKER", 0, APLAN);

    gotoxy(1, 16);
    outtext_xy("THANKS TO C.DOTY SEMPAI", 0, APLAN);
    gotoxy(1, 17);
    outtext_xy("    ALL HE DID,DOES & WILL DO!", 0, APLAN);

    gotoxy(1, 19);
    outtext_xy("THANKS TO ARI FELDMAN", 0, APLAN);
    gotoxy(1, 20);
    outtext_xy("                FREE SPRITELIB", 0, APLAN);

    gotoxy(1, 22);
    outtext_xy("EMAIL ME IF YOU WANT INFO OR", 0, APLAN);
    gotoxy(1, 23);
    outtext_xy("HELP ME WITH GFX OR MUSIC", 0, APLAN);
    
    
    gotoxy(1, 24);
    outtext_xy("YOU'RE LISTING MY 1ST MUSIC", 0, APLAN);*/

    
    fade(pal_black, pal_menu, 0, 2);
/*    set_colors(0, pal_menu); */
    
    i=1;
    j=0;
    while (i)
    {
	joy= read_joypad1();
    	if (joy)
    	{
	       	switch(joy & 0xff)
	       	{
	       		case BUTTON_S:
	       		case BUTTON_A:
	       		case BUTTON_B:
	       		case BUTTON_C:
	       			i=0;
				/* shut off the songs :) */
				init_synth();
    				init_song_player();
	       			break;
	       		default:
	       			break;
	       	}
	 }
	 
	 if ( j < (32*8*3) )	j++;
	 
	switch( (j/3) - 4*8) /* 8 blocks invibles */
	{
		case 2*8:
			gotoxy(1, 2);
			outtext_xy("THIS IS MY LITTLE DEMO FOR THE", 0, APLAN);
			break;
		case 3*8:
    			gotoxy(1, 3);
 			outtext_xy("Y2KODE COMPETITION.", 0, APLAN);
 			break; 			
		case 5*8:
			gotoxy(1, 5);
    			outtext_xy("IT'S FAR FROM A COMMERCIAL", 0, APLAN);
    			break;
    		case 6*8:
    			gotoxy(1, 6);
    			outtext_xy("GAME BUT I'M PROUD OF IT", 0, APLAN);
    			break;
		case 7*8:    			
    			gotoxy(1, 7);
    			outtext_xy("SINCE IT'S MY FIRST FULL DEMO", 0, APLAN);
    			break;
    		case 8*8:
    			gotoxy(1, 8);
    			outtext_xy("I MADE 'ALONE'!      ", 0, APLAN);
    			break;    			
    		case 10*8:
    			gotoxy(1, 10);
    			outtext_xy("THANKS TO PAUL LEE", 0, APLAN);
    			break;
    		case 11*8:
    			gotoxy(1, 11);
    			outtext_xy("       SGCC COMPILER & SUPPORT", 0, APLAN);
    			break;
		case 13*8:
			gotoxy(1, 13);
    			outtext_xy("THANKS TO LENNART STEINKE", 0, APLAN);
    			break;
    		case 14*8:
    			gotoxy(1, 14);
    			outtext_xy("                     MAP MAKER", 0, APLAN);
    			break;
    		case 16*8:
			gotoxy(1, 16);
    			outtext_xy("THANKS TO C.DOTY SEMPAI", 0, APLAN);
    			break;
		case 17*8:    			
    			gotoxy(1, 17);
    			outtext_xy("    ALL HE DID,DOES & WILL DO!", 0, APLAN);
    			break;
		case 19*8:
			gotoxy(1, 19);
    			outtext_xy("THANKS TO ARI FELDMAN", 0, APLAN);
    			break;
    		case 20*8:
    			gotoxy(1, 20);
    			outtext_xy("                FREE SPRITELIB", 0, APLAN);
			break;
    		case 22*8:
    			gotoxy(1, 22);
    			outtext_xy("EMAIL ME IF YOU WANT INFO OR", 0, APLAN);
    			break;
    		case 23*8:
    			gotoxy(1, 23);
    			outtext_xy("HELP ME WITH GFX OR MUSIC", 0, APLAN);
    			break;
    		case 24*8:
    			gotoxy(1, 24);
    			outtext_xy("YOU'RE LISTING MY 1ST MUSIC :)", 0, APLAN);
    			break;
		}	
	        generate_music();
		scrollv(j/3, 0);
	 	wait_sync();

    }


    j = ((j/8)/3)*3*8;
    scrollv(j/3, 0);


    
    for (j=1; j < 32*8; j+=4)
    {
	pl = (ulong *) GFXCNTL;
        *pl = GFX_WRITE_ADDR(HSCRL);
        pw = (uint *) GFXDATA;

        signe = j;

	for (i=0; i <32; i++) 
	{
		*pw = signe;  /* L1 field A */
		*pw = 0; /* L1 field B */
		*pw = 0; /* L2 */ 
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		*pw = 0;
		
		signe = (-1) * signe;
	}
        wait_sync();
   } 

   pw = (uint *) GFXCNTL;
   *pw = 0x8b00;   /* reg 11 - $0000abcd a=extr.int b=vscr cd=hscr */
   
   RAZ();
   
}	

/*************  Test_Joy() sub-program  *********/
/* Test the user action on Joypad and make the 	*/
/* change needed				*/
/* This time, all the cases are tested		*/
/************************************************/
void Test_Joy()
{
    register uint joy;
    register uchar contact;

    joy= read_joypad1();

    if (joy)
    {
	if (!cPaused)
	{
		contact = TilesContact(&Mick);
		
        	switch(joy & 0xff)
        	{
        	/* we forget the S+A+B(+C)+Dir since it's too hard to do it!! :) */
        	case BUTTON_S+ BUTTON_A+ BUTTON_B+ BUTTON_C:
        		ResetState=1;
        		break;
        	case BUTTON_S+ BUTTON_A:
        	case BUTTON_S+ BUTTON_A + JOY_LEFT:
        	case BUTTON_S+ BUTTON_A + JOY_LEFT + JOY_UP:
        	case BUTTON_S+ BUTTON_A + JOY_LEFT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_A + JOY_RIGHT:
        	case BUTTON_S+ BUTTON_A + JOY_RIGHT + JOY_UP:
        	case BUTTON_S+ BUTTON_A + JOY_RIGHT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_A + JOY_UP:
        	case BUTTON_S+ BUTTON_A + JOY_DOWN:
        	case BUTTON_S+ BUTTON_B:
        	case BUTTON_S+ BUTTON_B + JOY_LEFT:
        	case BUTTON_S+ BUTTON_B + JOY_LEFT + JOY_UP:
        	case BUTTON_S+ BUTTON_B + JOY_LEFT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_B + JOY_RIGHT:
        	case BUTTON_S+ BUTTON_B + JOY_RIGHT + JOY_UP:
        	case BUTTON_S+ BUTTON_B + JOY_RIGHT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_B + JOY_UP:
        	case BUTTON_S+ BUTTON_B + JOY_DOWN:
        	case BUTTON_S+ BUTTON_C:
        	case BUTTON_S+ BUTTON_C + JOY_LEFT:
        	case BUTTON_S+ BUTTON_C + JOY_LEFT + JOY_UP:
        	case BUTTON_S+ BUTTON_C + JOY_LEFT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_C + JOY_RIGHT:
        	case BUTTON_S+ BUTTON_C + JOY_RIGHT + JOY_UP:
        	case BUTTON_S+ BUTTON_C + JOY_RIGHT + JOY_DOWN:
        	case BUTTON_S+ BUTTON_C + JOY_UP:
        	case BUTTON_S+ BUTTON_C + JOY_DOWN:
        		break;
        	case BUTTON_S:			
        		Pause();
        		break;
		case JOY_RIGHT + JOY_UP:
		case JOY_RIGHT + JOY_DOWN:
            	case JOY_RIGHT:
            		Mick.Dir = RIGHT;
                	Mick.Speed = WALK;      
                	if (Mick.Action != JUMP) Mick.Action = WALK;
                	break;
		case JOY_LEFT + JOY_UP:
		case JOY_LEFT + JOY_DOWN:
            	case JOY_LEFT:
	                Mick.Dir = LEFT;
        	        Mick.Speed = WALK;        	        
                	if (Mick.Action != JUMP)    Mick.Action = WALK;
                	break;
            	case BUTTON_A + JOY_UP:
		case BUTTON_A + JOY_DOWN:
            	case BUTTON_A:                  /* Jump */
	                if (Mick.Action != JUMP)
        	        {
                		Mick.Speed  = STANDUP;
	                    	Mick.lastDir = Mick.Dir;
                    		InitJump_Hero(&Mick);
                	}
                	break;
            	case JOY_RIGHT + BUTTON_A + JOY_UP:
            	case JOY_RIGHT + BUTTON_A + JOY_DOWN:
            	case JOY_RIGHT + BUTTON_A:      /* Jump to the right */
                	Mick.Dir = RIGHT;
                	Mick.Speed = WALK;
                	if (Mick.Action != JUMP)	InitJump_Hero(&Mick);
                	break;
            	case JOY_LEFT + BUTTON_A + JOY_UP:
            	case JOY_LEFT + BUTTON_A + JOY_DOWN:
            	case JOY_LEFT + BUTTON_A:       /* Jump to the left */
	                Mick.Speed = WALK;
                	Mick.Dir = LEFT;
                	if (Mick.Action != JUMP)	InitJump_Hero(&Mick); 
                	break;
            	case JOY_RIGHT + BUTTON_B + JOY_UP:
            	case JOY_RIGHT + BUTTON_B + JOY_DOWN:
            	case JOY_RIGHT + BUTTON_B:
	                Mick.Dir = RIGHT;
                	Mick.Speed = WALK;          /* if jumping */
                	if (Mick.Action != JUMP)
                	{
                    		Mick.Action = RUN;
                    		Mick.Speed = RUN;
                	}
                	break;
            	case JOY_LEFT + BUTTON_B + JOY_UP:
            	case JOY_LEFT + BUTTON_B + JOY_DOWN:
            	case JOY_LEFT + BUTTON_B:
                	Mick.Dir = LEFT;
                	Mick.Speed = WALK;          /* if jumping */
                	if (Mick.Action != JUMP)
                	{
                    		Mick.Action = RUN;
                    		Mick.Speed = RUN;
                	}
                	break;
            	case JOY_RIGHT + BUTTON_B + BUTTON_A + JOY_UP:
            	case JOY_RIGHT + BUTTON_B + BUTTON_A + JOY_DOWN:
            	case JOY_RIGHT + BUTTON_B + BUTTON_A:      /* Jump running to the right */
                	Mick.Dir = RIGHT;
                	Mick.Speed = WALK;          /* if jumping */
                	if (Mick.Action != JUMP)
                	{
                    		Mick.Speed = RUN;     
                    		InitJump_Hero(&Mick);
                	}
                	break;
            	case JOY_LEFT + BUTTON_B + BUTTON_A + JOY_UP:
            	case JOY_LEFT + BUTTON_B + BUTTON_A + JOY_DOWN:
            	case JOY_LEFT + BUTTON_B + BUTTON_A:       /* Jump running to the left */
                	Mick.Dir = LEFT;
                	Mick.Speed = WALK;          /* if jumping */
                	if (Mick.Action != JUMP)
                	{
	                    	Mick.Speed = RUN;
        	            	InitJump_Hero(&Mick);
                	}
                	break;
            	default:
                	if (Mick.Action != JUMP)
                	{
                    		Mick.Speed = STANDUP;
                    		Mick.Action = STANDUP;
                    		Mick.Step=0;
                	}
        	}
	}
	else
	{
		switch(joy & 0xff)
        	{
        	case BUTTON_S:
        		Pause();        		
        		break;
        	}
        }        	
    }
}



/*************  Redraw sub-program  *************/
/* Redraw the screen with the new infos on	*/
/* Hero and the map				*/
/************************************************/
void Redraw()
{
        register uint x, y;
        register uint myTile;
        
        switch (Mick.Action)
        {
        	case DIE:
        		Die_Hero(&Mick);
        		break;               	
		case STANDUP:
               	case WALK:
               	case RUN:
               	case JUMP:
                       	RunWalk_Hero(&Mick);                       	
               		break;
        }        	
        
        
        x = (Mick.PosAct - Mick.PosX)>>3;
        	        
        /* using %, it's more precise */
        if (xwrite1<0)    	xwrite1 = (64*8) + xwrite1; /* since xwrite < 0 */
        if (xwrite1>=(64*8))  	xwrite1 =  xwrite1 - (64*8);
        if (xwrite2<0)    	xwrite2 = (64*8) + xwrite2;
        if (xwrite2>=(64*8))  	xwrite2 = xwrite2 - (64*8);
        
	scrollh(-(Mick.PosAct - Mick.PosX), -(Mick.PosAct - Mick.PosX)/3 );
		
        for (y=0; y< 28; y++)
        {
  		myTile = FirstTile + Fringe[x+47+(y*FringeWidth)].sTileIdx;                
                show_tiles(myTile, myTile, 0, xwrite1>>3, y, APLAN, 0, 0, 0);
                myTile = FirstTile + Fringe[x-15+(y*FringeWidth)].sTileIdx;                
                show_tiles(myTile, myTile, 0, xwrite2>>3, y, APLAN, 0, 0, 0); 

/*  		myTile = BaseIdx + Base[x/3+47+(y*BaseWidth)];
                show_tiles(myTile, myTile, 2, xwrite1>>3, y, BPLAN, 0, 0, 0);
                myTile = BaseIdx + Base[x/3-15+(y*BaseWidth)];                
                show_tiles(myTile, myTile, 0, xwrite2>>3, y, BPLAN, 0, 0, 0); */
        }

        DrawStep_Hero(&Mick);
};

/**  Wait sub-program  **/
/* Wait the time given	*/
/************************/
void Wait( Time )
uint Time;
{
	register uint x;
	
	for (x = 0; x<Time;x++)
		wait_sync();
};


/*******  Pause	*********/
/* Function called when	*/
/* start pressed	*/
/************************/
void Pause()
{
	if (cPaused)
		cPaused = 0;
	else
		cPaused = 1;
	
	/* else it's to quick and you'll never see the pause */
	Wait(10);
};




/*****************  Initialize GFX  ****************/
/* Read the comment for more info on each register */
/***************************************************/
void Init_GFX()
{
    register uint *pw;

    pw = (uint *) GFXCNTL;

    *pw = 0x8016;   /* reg. 0 - Enable HBL */
    *pw = 0x8174;   /* reg. 1 - Enable display, VBL, DMA + VCell size (28) */
    *pw = 0x8230;   /* reg. 2 - Plane A =$30*$400=$C000 */
    *pw = 0x832C;   /* reg. 3 - Window  =$2C*$400=$B000 */
    *pw = 0x8407;   /* reg. 4 - Plane B =$7*$2000=$E000 */
    *pw = 0x855F;   /* reg. 5 - sprite table begins at $BE00=$5F*$200 */
    *pw = 0x8600;   /* reg. 6 - not used */
    *pw = 0x8700;   /* reg. 7 - Background Color number*/
    *pw = 0x8800;   /* reg. 8 - not used */
    *pw = 0x8900;   /* reg. 9 - not used */
    *pw = 0x8a01;   /* reg 10 - HInterrupt timing */
    *pw = 0x8b00;   /* reg 11 - $0000abcd a=extr.int b=vscr cd=hscr */
    *pw = 0x8c08;   /* reg 12 - hcell mode + shadow/highight + interlaced mode */
    *pw = 0x8d2E;   /* reg 13 - HScoll Table = $B800 */
    *pw = 0x8e00;   /* reg 14 - not used */
    *pw = 0x8f02;   /* reg 15 - auto increment data */
    *pw = 0x9001;   /* reg 16 - scrl screen v&h size */
    
    extWIDTH = 64;
    
    *pw = 0x9100;   /* reg 17 - window hpos */
    *pw = 0x92ff;   /* reg 18 - window vpos */
};


