/*
#include "genesis.h"
#include "map.h"
#include "hero.h"
*/

#include "all.h"


/*****  LoadTile_Hero sub-program  ******/
/* Load the hero's tiles		*/
/****************************************/
void LoadTile_Hero()
{
    /* Load Mick Steps */    
    
    /* Walk/Run steps*/
    dma_vram_copy(shaolin0, ADR_MICK0, 32 * shaolin0_HSize*shaolin0_VSize);
    dma_vram_copy(shaolin1, ADR_MICK0 + 32 * shaolin0_HSize*shaolin0_VSize, 32 * shaolin1_HSize*shaolin1_VSize);
    dma_vram_copy(shaolin2, ADR_MICK1, 32 * shaolin2_HSize*shaolin2_VSize);
    dma_vram_copy(shaolin3, ADR_MICK1 + 32 * shaolin2_HSize*shaolin2_VSize, 32 * shaolin3_HSize*shaolin3_VSize);
    dma_vram_copy(shaolin4, ADR_MICK2, 32 * shaolin4_HSize*shaolin4_VSize);
    dma_vram_copy(shaolin5, ADR_MICK2 + 32 * shaolin4_HSize*shaolin4_VSize, 32 * shaolin5_HSize*shaolin5_VSize);            

    /* Jump steps */
    
    
    /* Hurt / Die steps */
    
    set_colors( 1, pal_shaolin); 
};


/***** Init_Hero sub-program ****/
/* Init the Hero values		*/
/********************************/
void Init_Hero( Hero )
struct HeroStruc *Hero;
{
    uint y;
    
    /* Pos 1 = 8pixels of the LeftScreen */
    Hero->PosX=SpriteList[0].sPosX;		/* Pos on the screen (8pixels) */
    Hero->PosY=SpriteList[0].sPosY;
    Hero->PosAct = SpriteList[0].sPosX;		/* Pos on the map */
    Hero->Step = 1;
    Hero->Dir = RIGHT;
    Hero->lastDir = RIGHT;
    Hero->Speed = STANDUP;    
    Hero->Action = STANDUP;
    Hero->Width = shaolin0_HSize; 
    Hero->Height = shaolin0_VSize + shaolin1_VSize;
    Hero->DisableJump = 0;
    Hero->DisableHurt = 0;
    Hero->Life = 100;
    
    RunWalk_Hero( Hero );
    
};

/*********  DrawStep sub-program  *********/
/* To make effect of a 'human' walk, each */
/* step is a different picture/tiles 	  */
/* To do:				  */
/*	Difference between running, 	  */
/*		jumping, .....'s steps    */
/******************************************/
void DrawStep_Hero( Hero )
struct HeroStruc *Hero;
{
	
	switch(Hero->Action)
	{
		case STANDUP:
		case WALK:
		case RUN:
	        	/* Hero.Dir << 11  to invert Mick if he goes left, see DEF_SPRITE() in GENESIS.C for more details */
        		switch (Hero->Step)
        		{
	                	case STEP1:
	                        	def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK0 / 32) + (Hero->Dir << 11) ); 
        	                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK0 / 32) + (Hero->Dir << 11));
                	        	break;
                		case STEP2:
		                        def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK1 / 32) + (Hero->Dir << 11) ); 
        	                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK1 / 32) + (Hero->Dir << 11));
                        		break;
                		case STEP3:
		                        def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK2 / 32) + (Hero->Dir << 11) );
        	                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK2 / 32) + (Hero->Dir << 11) );
                	        	break;
                		case STEP4:
		                        def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK1 / 32) + (Hero->Dir << 11) );
        	                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK1 / 32) + (Hero->Dir << 11) );
                	        	break;
                		case STEP0:
	                        	Hero->Step=1;
        		}
        		break;
        	case JUMP:
                       	def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK0 / 32) + (Hero->Dir << 11) ); 
                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK0 / 32) + (Hero->Dir << 11));
        		break;
        	case DIE:
                      	def_sprite(1, Hero->PosX, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK0 / 32) + (Hero->Dir << 11) ); 
                	def_sprite(2, Hero->PosX, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK0 / 32) + (Hero->Dir << 11));
        		break;
        }
        
        
        if (Hero->DisableHurt)
        {
        	if ( IMPAIR(Hero->DisableHurt/10) )	/* to made it blink */
		{
                       	def_sprite(1, 40*8, Hero->PosY,    0xf00, 0x2000 + (ADR_MICK0 / 32) + (Hero->Dir << 11) ); 
	               	def_sprite(2, 40*8, Hero->PosY+32, 0xc00, 0x2000 + (16 + ADR_MICK0 / 32) + (Hero->Dir << 11));
	        }		
        }
};


/*****  Walk_Hero sub-program  **********/
/* Make the hero walk if possible	*/
/****************************************/
void RunWalk_Hero( Hero )
struct HeroStruc *Hero;
{
        register uchar Cond1;
        register uchar Cond2;                
	register uchar contact;
	
	int x1, y1; /* for jump test only */
	int value;
	
	contact = TilesContact(Hero);

	Cond1 = (Hero->Dir==RIGHT) & ( (Hero->PosAct>>3) < LIMIT_RIGHT ) ; 
	Cond2 = (Hero->Dir==LEFT)  & ( (Hero->PosAct) > (LIMIT_LEFT<<3) );


	if (contact & CDOWN)
        {
        	/* only test it when go down */
        	if  ( (Hero->Action == JUMP) && (Hero->Jumping.VelY <= 0) )
        	{
        		Hero->Jumping.IsFinish = 1;
        		Hero->DisableJump=1;
        		Hero->Action = WALK;
        		Hero->PosY = (Hero->PosY>>3)<<3;
        		x1 = (Hero->PosAct)>>3;	
        		y1 = (Hero->PosY>>3)+(Hero->Height)-1;
        		while ( TileProp( x1,y1 ) != WLK_FULL )
        		{
       				Hero->PosY-=8;
        			y1 = (Hero->PosY>>3)+(Hero->Height)-1;
        		}
        	}
        	/* if velocity > 8 then Hero/8 isn't enought and Hero walk IN the ground, so adjust him */
        	if (Hero->Action != JUMP)
        	{
        		Hero->PosY = (Hero->PosY>>3)<<3;
        		x1 = (Hero->PosAct)>>3;	
        		y1 = (Hero->PosY>>3)+(Hero->Height)-1;
        		while ( TileProp( x1,y1 ) != WLK_FULL  )
        		{
       				Hero->PosY--;
        			y1 = (Hero->PosY>>3)+(Hero->Height)-1;
        		}
        	 }

        }
        
        else 
        {
	       	if  (Hero->Action != JUMP)	
       		{        	
  	                Hero->lastDir = Mick.Dir;                    	
        		InitFalling_Hero( Hero );
       		}
	}
	
	
	if (contact & CUP)
	{
		if  (Hero->Action == JUMP) Hero->Jumping.VelY = 0;
	}
	if (contact & CRIGHT)
	{
		Cond1 = 0;
	}
	if (contact & CLEFT)
	{
		Cond2 = 0;
	}
     	
     	if  ( Hero->Action == JUMP )
       	{
       		if (Hero->Jumping.VelY > 0)
 			Hero->Step = JUMP_STEP1;
 		else
        		Hero->Step = JUMP_STEP2;
	
	 	Hero->Jumping.VelY -= Hero->Jumping.Accel;
       		Hero->PosY -= Hero->Jumping.VelY;
       		/* >0 because if you jump too high, Hero->PosY of a negatif number give 0x1xxx so >28*/
       		if ( (Hero->PosY>0) && ((Hero->PosY>>3) >= (28 - Hero->Height)) )
       		{
       			InitDie_Hero(Hero);
       			return;
       		}
       	}
       	
       	if (Cond1 || Cond2)
        {
                Hero->Step++;
                value=Hero->Speed * SIGNDIR(Hero->Dir);/* if Left SIGNDIR return -1 else +1 */
                if ( Hero->Action == JUMP )	value*=2;
                if ( Hero->PosAct+value < (8*(LIMIT_RIGHT - 32) + Hero->PosX) )
        	{
        		Hero->PosAct+= value;
                
                	/* i can't draw inexistant map (ie i can't draw map[-1]) */
        		if (Hero->PosAct <= Hero->PosX )
        			Hero->PosAct=Hero->PosX;
        		else
        		{
				xwrite1+=value;
        			xwrite2+=value;
        		}        		
        	}
        	else
        		LevelEnd = 1;
        }
        
        
        /* To avoid ball effect : constant jump when button never release */
        if (Hero->DisableJump)	Hero->DisableJump++;
        if (Hero->DisableJump==10) Hero->DisableJump=0;	/*10 = about 1s*/
        
        /* To avoid collide detection when already hurted */
        if (Hero->DisableHurt)	Hero->DisableHurt++;
        if (Hero->DisableHurt==60) Hero->DisableHurt=0;        
};


/** InitJump_Hero sub-program  **/
/* Init a jump action 		*/
/********************************/
void InitJump_Hero( Hero )
struct HeroStruc *Hero;
{
        if (Hero->DisableJump)	return;
        
        play_sample(Boing, BoingEnd - Boing);
        
        Hero->Action = JUMP;
        Hero->Step = JUMP_STEP1;
        Hero->Jumping.IsFinish = 0;
        /*
        Hero->Jumping.ScrollValue = 0;
        Hero->Jumping.IncScroll = 1;
        Hero->Jumping.VelX = 10;
         */
        Hero->Jumping.VelY = 12;
        Hero->Jumping.Accel = 1;
};


/* InitFalling_Hero sub-program */
/* Init a jump action 		*/
/********************************/
void InitFalling_Hero( Hero )
struct HeroStruc *Hero;
{	
        Hero->Action = JUMP;
        Hero->Step = JUMP_STEP2;
        Hero->Jumping.IsFinish = 0;
 	/*
 	Hero->Jumping.ScrollValue = 0;
        Hero->Jumping.IncScroll = 1;
        Hero->Jumping.VelX = 10;
	 */	 
        Hero->Jumping.VelY = 0;
        Hero->Jumping.Accel = 1;
};


/***  Init_Jump sub-program  ****/
/* Init a jump action 		*/
/********************************/
void InitDie_Hero( Hero )
struct HeroStruc *Hero;
{
        cInteractif = 0;
 
        Hero->Life = 0;
	Hero->Action = DIE;
        Hero->Step = DYING_STEP1;
        Hero->Jumping.IsFinish = 0;
        Hero->Jumping.VelY = 12;
        Hero->Jumping.Accel = 1;
};


/***  Die_Hero sub-program  ****/
/* Dying redraw function	*/
/********************************/
void Die_Hero( Hero )
struct HeroStruc *Hero;
{
	/*Hero->Step = DYING_STEP1;*/
 	Hero->Jumping.VelY -= Hero->Jumping.Accel;
	Hero->PosY -= Hero->Jumping.VelY;
        if (Hero->Speed)
        	Hero->PosAct-=Hero->Speed*SIGNDIR(Hero->Dir);
	else
		Hero->PosAct--;
        

	if ( (Hero->Jumping.VelY < 0) && ((Hero->PosY>>3)>28) )
	{
		set_colors( 0, pal_black); 
		set_colors( 1, pal_black); 
		 set_colors( 2, pal_black);
		set_colors( 3, pal_black); 
		cInteractif = 1;
		AnimText = (AnimText /100) * 100;
		Init_Map();
		Init_Hero( Hero );
		Redraw();
		set_colors( 1, pal_shaolin); 
		set_colors( 2, pal_enemy);
		/* pal 0 & 3 are initialized in Init_Map() */
	}
}