
#include "genesis.h"

#ifndef _INC_HERO_

/** address of Mick's tiles **/
/* since Mick something like 
*               *****
*               *****
*               *****
*               *****               
* when each * = 1 tile = 32bytes
*/


/**** in SOUND.S ******/
extern uchar Boing[];
extern uchar BoingEnd[];


/**** in SHAOLIN1.S **************/
/**** tiles for normal Mick ******/
extern uint pal_shaolin[];
extern ulong shaolin0[];
extern uint shaolin0_HSize;
extern uint shaolin0_VSize;
extern ulong shaolin1[];
extern uint shaolin1_HSize;
extern uint shaolin1_VSize;
extern ulong shaolin2[];
extern uint shaolin2_HSize;
extern uint shaolin2_VSize;
extern ulong shaolin3[];
extern uint shaolin3_HSize;
extern uint shaolin3_VSize;
extern ulong shaolin4[];
extern uint shaolin4_HSize;
extern uint shaolin4_VSize;
extern ulong shaolin5[];
extern uint shaolin5_HSize;
extern uint shaolin5_VSize;

#define ADR_MICK0       ( 32 + (32 * NbTile) + (32*96) + (32*window0_HSize*window0_VSize) + (32 * NbBaseTile))
#define ADR_MICK1       ( ADR_MICK0 + (32 * 4 * 4) + (32 * 4 *1) )
#define ADR_MICK2       ( ADR_MICK1 + (32 * 4 * 4) + (32 * 4 *1) )
/*#define ADR_MICK3       ( ADR_MICK2 + (32 * 4 * 4) + (32 * 4 *1) )*/

/** to know where Mick goes **/
#define LEFT            1
#define RIGHT           0

/** what Mick is going **/
#define STANDUP         0
#define WALK            1
#define RUN             2
#define JUMP            3
#define FLY		5
#define DIE  		9

/** Steps	**/
#define STEP1		0x01
#define STEP2		0x04
#define STEP3		0x08
#define STEP4		0x0C
#define DYING_STEP1	0x01
#define DYING_STEP2	0x08
#define JUMP_STEP1	0x01
#define JUMP_STEP2	0x08
#define STEP0		0x0f


#define SIGNDIR(x)	( (x==LEFT)?-1:1 )


/*************    Variables  *************/

struct JumpStruc {
        uint IsFinish;          /* if TRUE then Jump is Finish */
        /*
        uint ScrollValue;       
        uint IncScroll;         
        int VelX;
        */
        int VelY;
        uint Accel;        
};

struct HeroStruc {
        int PosX;		/* Posx in screen (doesn't change) */
        int PosY;		/* Posy in screen (change with map) */
        int PosAct;    		/* actual relative pos of Mick  */
        char Speed;
        uchar lastDir;
        uchar Dir;      	/* where Mick goes, went        */
        uchar Action;
        uchar Step;    		/* actual step of Mick's walk   */
        uint Width;
        uint Height;
        uchar DisableJump; 	/* To avoid ball effect : constant jump when button never release */
        uchar DisableHurt; 	/* To avoid collide detection when already hurted */
        char Life;		/* our energy */
        struct JumpStruc Jumping;
}Mick;

/************** Function prototypes *************/
void LoadTile_Hero();
void Init_Hero(Hero);
uint Adjust_Hero(Hero);
void RunWalk_Hero(Hero);
void InitJump_Hero(Hero);
void InitFalling_Hero(Hero);
void InitDie_Hero(Hero);
void Die_Hero(Hero);

#define _INC_HERO_

#endif


