/*
#include "genesis.h"
#include "map.h"
*/

#include "all.h"

/* Sozobon limitations!!! */         
/* The size of a single structure or array may not exceed 32K.  */

/****** LoadTile_Map ****/
/* Load tiles for map	*/
/************************/
void LoadTile_Map()
{
	dma_vram_copy(tiledata, 0, 32*96);
	dma_vram_copy(window0, 32*96, 32*window0_HSize*window0_VSize);
    	dma_vram_copy(autograb, 32*96 + 32*window0_HSize*window0_VSize, 32 + 32 * NbTile);
    	dma_vram_copy(BaseTile, 32*96 + 32*window0_HSize*window0_VSize + 32 + 32 * NbTile, 32*32*NbBaseTile);
    	FirstTile = 96 + window0_HSize*window0_VSize;
    	BaseIdx = 97 + window0_HSize*window0_VSize + NbTile;
}


/*** Init_Tiles sub-program  ****/
/* Load the tiles of Fringe map	*/
/* and show the part visible	*/
/********************************/
void Init_Map()
{
        ShowFringe(0,47,FirstTile);
        ShowBase(0,60,BaseIdx);
        ShowWindow();
   	
	set_colors( 0, pal_autograb); 
	set_colors( 3, pal_window);

      	xwrite1 = 47*8;
   	xwrite2 = 48*8;
};


/*** ShowFringe sub-program  ****/
/* Show column FirstCol to 	*/
/* LastCol of the map Fringe	*/
/* TileRef is the number of the	*/
/* first tile used by Fringe	*/
/********************************/
void ShowFringe( FirstCol, LastCol, TileRef)
uint FirstCol;
uint LastCol;
uint TileRef;
{
	register uint myTile;
    	register uint x, y;
    
    	/* Draw the first 48 columns of the Map */
    	for (y=0; y< 28; y++)
    	{
	        for (x=FirstCol;x < LastCol; x++)
        	{
        		myTile = TileRef + Fringe[x+(y*FringeWidth)].sTileIdx;
             		show_tiles( myTile, myTile, 0, x, y, APLAN, 0, 0, 0);
       		}
    	}
	
};



/***** ShowBase sub-program  ****/
/* Show column FirstCol to 	*/
/* LastCol of the map Base   	*/
/* TileRef is the number of the	*/
/* first tile used by Base	*/
/********************************/
void ShowBase( FirstCol, LastCol, TileRef)
uint FirstCol;
uint LastCol;
uint TileRef;
{
	register uint myTile;
    	register uint x, y;
    
    	for (y=0; y< 28; y++)
    	{
	        for (x=FirstCol;x < LastCol; x++)
        	{
        		myTile = TileRef + Base[x+(y*BaseWidth)];
             		show_tiles( myTile, myTile, 2, x, y, BPLAN, 0, 0, 0);
		}

    	}
};




void ShowWindow()
{
    	
    	register uint x,y;
    	register uint myTile;

	extWIDTH = 32;    
    	for (y=0; y< 3; y++)
    	{
	        for (x=0;x < 32; x++)
        	{
        		myTile = 96 + x+(y*window0_HSize);
             		show_tiles( myTile, myTile, 3, x, y, WPLAN, 1, 0, 0);
       		}
    	}
	    
    	extWIDTH = 64;
};



uchar TilesContact( Hero )
struct HeroStruc *Hero;
{
	register int x1, x2;
	register int y1, y2;
	int tmpValue;
	uchar HalfY, HalfX;
	register uchar Contact;
	uint myTile;
	
	HalfX = 0;
	HalfY = 0;

	Contact = CNOTHING;
	
	/* we test the contact in the NEXT move */	
	tmpValue = (Hero->PosAct) + (SIGNDIR(Hero->Dir)*(Hero->Speed));
	x1 = tmpValue>>3;
	if ( (tmpValue&0x7)>3) HalfX++;
	x2 = x1 + (Hero->Width) - 1;
		
	y1 = (Hero->PosY)>>3;	 
	if ( (Hero->PosY&0x7) > 3 ) HalfY++;
	y2 = y1 + (Hero->Height) - 1;
        
	if (y1 < 0) return(Contact);
	if (y1 > 27) return(Contact);

	if ( (TileProp(x1, y1-1)!=WLK_FULL) )	Contact |= CUP;
	if ( (TileProp(x2, y1-1)!=WLK_FULL) )	Contact |= CUP;
		
	if ( (TileProp(x1, y2+1)!=WLK_FULL) )	Contact |= CDOWN;
	if ( (TileProp(x2, y2+1)!=WLK_FULL) )	Contact |= CDOWN;

	if ( (TileProp(x1, y1)!=WLK_FULL) )	Contact |= CLEFT; 
	if ( (TileProp(x1, y2)!=WLK_FULL) )	Contact |= CLEFT;
			
	if ( (TileProp(HalfX+x2, y1)!=WLK_FULL) )	Contact |= CRIGHT; 
	if ( (TileProp(HalfX+x2, y2)!=WLK_FULL) )	Contact |= CRIGHT;	
	 
	return(Contact);
};

uchar TileProp( x, y)
int x;
int y;
{
	if (y>=0) 
	{
		/* MAP2S put WLK_FULL in empty tile (stileidx=0) */
		return (Fringe[x+(y*FringeWidth)].cWalk);
	}
	else
		return (WLK_FULL);
		
};


uint TileAt( x, y)
int x;
int y;
{
	return Fringe[x+(y*FringeWidth)].sTileIdx;
};







/******************** _ITOA *********************
 * Integer to Ascii in radix 10                 *
 *                                              *
 *      Made     by Kaneda in STDLIB.C          *
 ************************************************/
uchar *_itoa(value)
int value;
{
  char tmp[33];
  char *tp = tmp;
  int i;
  unsigned v;
  int sign;
  char *sp;

  int radix = 10;
  char string[];

  sp = string;

  sign = (value < 0);

  if (sign)
    v = -value;
  else
    v = (unsigned)value;

  while (v || tp == tmp)
  {
    i = v % radix;
    v = v / radix;
    if (i < 10)
      *tp++ = i+'0';
    else
      *tp++ = i + 'a' - 10;
  }

  if (sign)
    *sp++ = '-';

  while (tp > tmp)
    *sp++ = *--tp;

  *sp = 0;

  return string;
}

/*********** ShowLife ***********/
/* Print Life of a hero at col	*/
/* initx (in tile value)	*/
/********************************/
void ShowLife(Hero)
struct HeroStruc *Hero;
{
	uchar x,y;
	uchar initX;
	uint TileFull, TileHalf, TileEmpty;

	TileEmpty = 96 + 33;
	TileFull = 96 + 35;
	TileHalf = 96 + 43;

	extWIDTH = 32;    
   	
	initX = 3;
	if (Hero->Life%20)
	{
		for(x=0;x<(Hero->Life/20);x++, initX+=2)
		{
			show_tiles( TileFull, TileFull, 3, initX, 1, WPLAN, 1, 0, 0);
		}
		show_tiles( TileHalf, TileHalf, 3, initX, 1, WPLAN, 1, 0, 0);
		initX+=2;
		for(x=1+(Hero->Life/20);x<5;x++, initX+=2)
		{
			show_tiles( TileEmpty, TileEmpty, 3, initX, 1, WPLAN, 1, 0, 0);
		}
		
		
	}
	else 
	{
		for(x=0;x<(Hero->Life/20);x++, initX+=2)
		{
			show_tiles( TileFull, TileFull, 3, initX, 1, WPLAN, 1, 0, 0);
		}
		for(x=(Hero->Life/20);x<5;x++, initX+=2)
		{
			show_tiles( TileEmpty, TileEmpty, 3, initX, 1, WPLAN, 1, 0, 0);
		}		
	}
	
	extWIDTH = 64;    
    
}


void ShowText()
{
	char *LifeString;
	uchar x;

	if (AnimText%100 > 0)
	{
		AnimText++;
		return;
	}

	switch (AnimText/100)
	{
		case 0:
			LifeString = "THIS IS A TINY";
			break;
		case 2:
			LifeString = "GAME MADE FOR ";
			break;
		case 4:
			LifeString = "THE Y2KODE'S  ";
			break;
		case 6:
			LifeString = "PARTY! BE FREE";
			break;
		case 8:
			LifeString = "TO CONTACT ME ";
			break;
		case 10:
			LifeString = "AT KANEDA@CHEZ";
			break;
		case 12:
			LifeString = ".COM FOR NEXT ";
			break;
		case 14:
			LifeString = "VERSION OR TO ";
			break;
		case 16:
			LifeString = "JOIN MY GENNY ";
			break;
		case 18:
			LifeString = "DEV GROUP!!!!!";
			break;
	}			

	extWIDTH = 32;		
	for (x=0; x < strlen(LifeString); x++)
	{
			show_tiles( LifeString[x]-32, LifeString[x]-32, 3, 17+x, 1, WPLAN, 1, 0, 0);
	}		
	extWIDTH = 64;
	
	AnimText++;
	if (AnimText>=2000) AnimText = 0;	
}
