#ifndef _INC_MAP_

/** From MapMaker **/
#define WLK_FREE        0x00            /* All of the tile is walkable */
#define WLK_FULL        0x01            /* The tile is un- walkable (FOR ME: INACTIF TILE) */

/** Not Used ....yet **/
#define WLK_LOWER       0x02            /* The lower half is walkable */
#define WLK_UPPER       0x03            /* The upper half is walkable */
#define WLK_LEFTUP      0x04            /* The Upper- Left half is walkable */
#define WLK_RGHTDWN     0x05            /* The Lower- Right half is walkable */
#define WLK_LEFTDWN     0x06            /* The Lower- Left half is walkable */
#define WLK_RGHTUP      0x07            /* The Upper- Right half is walkable */
#define WLK_NORTH       0x10            /* Can be passed south -> north */
#define WLK_SOUTH       0x20            /* Can be passed north -> south */
#define WLK_EAST        0x40            /* Can be passed west  -> east */
#define WLK_WEST        0x80            /* Can be passed east  -> west */
#define WLK_ALWAYS      0xf0            /* Can be passed in every direction */

/** Columns/Tiles Limits when moving Mick **/
#define LIMIT_LEFT      0
#define LIMIT_RIGHT     (FringeWidth)


/** What touch? **/
#define CNOTHING        0x00
#define CLEFT           0x01  
#define CRIGHT          0x02
#define CUP		0x04
#define CDOWN		0x08


struct  CellStruct {
	uint	sTileIdx;
	uchar   cWalk;
	ulong   lFlags;		
};

/* For the scrolling*/
int xwrite1;
int xwrite2; 


/* For the animated text */
uint AnimText;

/* tiles def */
extern uint pal_autograb[];
extern uint NbTile;
extern ulong autograb[];

extern uint NbBaseTile;
extern ulong BaseTile[];

/* tiles def */
extern uint pal_window[];
extern ulong window0[];
extern uint window0_HSize;
extern uint window0_VSize;

/* fringe map def */
extern ulong FringeHeight;
extern ulong FringeWidth;
extern struct CellStruct Fringe[];
uint	FirstTile;



/* base map def */
extern ulong BaseHeight;
extern ulong BaseWidth;
extern uint Base[];
uint BaseIdx;




/* Functions prototypes */
void LoadTile_Map();
void Init_Map();
void ShowFringe( FirstCol, LastCol, TileRef);
void ShowBase( FirstCol, LastCol, TileRef );
void ShowWindow();
uchar TilesContact( Hero );
uint TileAt( x,y );
uchar TileProp( x,y );

/* Window */
uchar *_itoa(value);
uint strlen(str);
void ShowLife(Hero);
void ShowText();


#define _INC_MAP_
#endif
