/*
#include "genesis.h"
#include "sprites.h"
*/

#include "all.h"


/* Sozobon limitations!!! */         
/* The size of a single structure or array may not exceed 32K.  */

/******* LoadTile_Object ********/
/* Load the tiles needed for	*/
/* the objects/enemies		*/
/********************************/
void LoadTile_Object()
{
/* Mosquito (1 sprite, 3 states) */
    dma_vram_copy(mosquito0, ADR_MOSQUITO0, 32 * mosquito0_HSize*mosquito0_VSize);
    dma_vram_copy(mosquito1, ADR_MOSQUITO1, 32 * mosquito1_HSize*mosquito1_VSize);
    dma_vram_copy(mosquito2, ADR_MOSQUITO2, 32 * mosquito2_HSize*mosquito2_VSize);
/* Fish (2 sprites, 2 states) */
    dma_vram_copy(fish0a, ADR_FISH0A, 32 * fish0a_HSize*fish0a_VSize);
    dma_vram_copy(fish0b, ADR_FISH0B, 32 * fish0b_HSize*fish0b_VSize);
    dma_vram_copy(fish1a, ADR_FISH1A, 32 * fish1a_HSize*fish1a_VSize);
    dma_vram_copy(fish1b, ADR_FISH1B, 32 * fish1b_HSize*fish1b_VSize);
/* Life 1 ( 1 sprite, 1 state) */
    dma_vram_copy(life1, ADR_LIFE1, 32 * life1_HSize*life1_VSize);
/* Kill ( 1 sprite, 1 state) */
    dma_vram_copy(kill, ADR_KILL, 32 * kill_HSize*kill_VSize); 
}




/***** Init_Object ******/
/* Make a sprites'list	*/
/* with the struct WE	*/
/* want, not MapMaker's	*/
/************************/
void Init_Object()
{
	register uint x;
	register uint j; /* first sprite nb free*/
	
	j=3; /* 1&2 = mick */
	
		
	for(x=0; x<NbrObj;x++) 
	{
		switch (ObjectList[x].lFlags)
		{
			case OBJ_HERO:
				SpriteList[0].lType = OBJ_HERO; /*ObjectList[x].lFlags&0xFFF0;*/
				SpriteList[0].sPosX = 8*( ObjectList[x].sPosX - (shaolin0_HSize/2) );
				SpriteList[0].sPosY = 8*( ObjectList[x].sPosY - (shaolin0_VSize + shaolin1_VSize) );
				break;
			case OBJ_LIFE1:
				SpriteList[x].lType = OBJ_LIFE1; /*ObjectList[x].lFlags&0xFFF0;*/
				SpriteList[x].sPosX = 8*( ObjectList[x].sPosX - (life1_HSize/2) );
				SpriteList[x].sPosY = 8*( ObjectList[x].sPosY - (life1_VSize) +1);
				SpriteList[x].Damage = -20;
				SpriteList[x].Step = VISIBLE;
				SpriteList[x].sNumSpr = j;
/*				SpriteList[x].lSpecial = ObjectList[x].lFlags&0x000F;	*/
				SpriteList[x].Width = life1_HSize;
				SpriteList[x].Height = life1_VSize;
/*				SpriteList[x].sDestX = SpriteList[x].sPosX;
				SpriteList[x].sDestY = SpriteList[x].sPosY;
				SpriteList[x].Dir = 0;
				SpriteList[x].Action = 0;
				SpriteList[x].Life = 0;*/
				j++; /* Heart takes 1 sprite */
				break;
			case OBJ_LIFE2:
				break;
			case OBJ_FISH:
				Init_Fish( &SpriteList[x], &ObjectList[x],j);
				j+=2; /* Fish takes 2 sprites */
				break;
			case OBJ_MOSQUITO:
				Init_Mosquito( &SpriteList[x], &ObjectList[x],j);
				j++; /* Mosquito takes 1 sprite */
				break;
			case OBJ_KILL:
				SpriteList[x].lType = OBJ_KILL;
				SpriteList[x].sPosX = 8*( ObjectList[x].sPosX - (kill_HSize/2) );
				SpriteList[x].sPosY = 8*( ObjectList[x].sPosY - (kill_VSize) +1);
				SpriteList[x].Damage = 100;
				SpriteList[x].sNumSpr = j;
/*				SpriteList[x].Step = 0;
				SpriteList[x].lSpecial = ObjectList[x].lFlags&0x000F;	*/
				SpriteList[x].Width = kill_HSize;
				SpriteList[x].Height = kill_VSize;
/*				SpriteList[x].sDestX = SpriteList[x].sPosX;
				SpriteList[x].sDestY = SpriteList[x].sPosY;
				SpriteList[x].Dir = 0;
				SpriteList[x].Action = 0;
				SpriteList[x].Life = 0;*/
				j++;
				break;
		}
	}
	set_colors( 2, pal_enemy);	
}


/* Init_Fish */
void Init_Fish( myFish, myFishPreDef, SprNum)
struct  ObjectStruct *myFish;
struct 	MapMakerObjectStruct *myFishPreDef;
uint 	SprNum;
{
	myFish->lType = OBJ_FISH;/*myFishPreDef->lFlags&0xFFF0;*/
	myFish->sPosX = 8*(myFishPreDef->sPosX - (fish0a_HSize/2) ); 
	myFish->sPosY = 8*28;
	myFish->sDestX = myFish->sPosX;
	myFish->sDestY = 8*(myFishPreDef->sPosY - (fish0a_VSize+fish0b_VSize) );
	myFish->Dir = UP;
	myFish->Action = JUMP;
	myFish->Step = 1;
	myFish->Width = fish0a_HSize;
	myFish->Height = fish0a_VSize+fish0b_VSize;
	myFish->Damage = 20;
	myFish->Life = 10;
/*	myFish->lSpecial = myFishPreDef->lFlags&0x000F;*/
	myFish->sNumSpr = SprNum;
}


/* Init_Mosquito */
void Init_Mosquito( myMosquito, myMosquitoPreDef, SprNum)
struct  ObjectStruct *myMosquito;
struct 	MapMakerObjectStruct *myMosquitoPreDef;
uint 	SprNum;
{
	myMosquito->lType = OBJ_MOSQUITO; /*myMosquitoPreDef->lFlags&0xFFF0;*/
	myMosquito->sPosX = 8*(myMosquitoPreDef->sPosX - (mosquito0_HSize/2) );
	myMosquito->sPosY = 8*(myMosquitoPreDef->sPosY - mosquito0_VSize +1);
	myMosquito->sDestX = myMosquito->sPosX - (10*8);
	myMosquito->sDestY = myMosquito->sPosY;
	myMosquito->Dir = LEFT;
	myMosquito->Action = FLY;
	myMosquito->Step = 1;
	myMosquito->Width = mosquito0_HSize;
	myMosquito->Height = mosquito0_VSize;
	myMosquito->Damage = 10;
	myMosquito->Life = 10;
/*	myMosquito->lSpecial = myMosquitoPreDef->lFlags&0x000F;*/
	myMosquito->sNumSpr = SprNum;
}


/************* RedrawactifSpr sub-program  **************/
/* Redraw the actifs sprites ie the sprites VISIBLE	*/
/********************************************************/
void RedrawActifSpr()
{
 	register uint x;
 	register uint NbSpr; /* number of sprites to show (even if not visible)*/
 	
 	/* Show sprite begin at 1 not 0 as usual */
 	NbSpr = 2;
 	for(x=1; x< NbrObj ;x++)
	{
		switch (SpriteList[x].lType)
		{
		/*	case OBJ_HERO:
				NbSpr+=2;
				break;*/
			case OBJ_LIFE1:
				if ( (SpriteList[x].sPosX > (Mick.PosAct-Mick.PosX-4*8)) && (SpriteList[x].sPosX < (8*40+Mick.PosAct)) && (SpriteList[x].Step == VISIBLE) )
                        	{
	       				NbSpr++;
                        		def_sprite(NbSpr,    SpriteList[x].sPosX -Mick.PosAct + Mick.PosX, SpriteList[x].sPosY,    0xa00, 0x4000 + (ADR_LIFE1 / 32) ); 
		        	}
				break;
			/*case OBJ_LIFE2:
				NbSpr++;
				break;*/
			case OBJ_FISH:
	               		if ( (SpriteList[x].sPosX > (Mick.PosAct-Mick.PosX-4*8)) && (SpriteList[x].sPosX < (8*40+Mick.PosAct)) )
	               		{
                        		NbSpr++;
                        		SpriteList[x].sNumSpr = NbSpr;
                        		NbSpr++;
                        		AnimFish(&SpriteList[x]);
                        	}       				
				break;
			case OBJ_MOSQUITO:
                        	if ( (SpriteList[x].sPosX > (Mick.PosAct-Mick.PosX-4*8)) && (SpriteList[x].sPosX < (8*40+Mick.PosAct)) )
                        	{
                        		NbSpr++;
                        		SpriteList[x].sNumSpr = NbSpr;
                        		AnimMosquito(&SpriteList[x]);
                        	}				
				break;
			case OBJ_KILL:
				if ( (SpriteList[x].sPosX > (Mick.PosAct-Mick.PosX-4*8)) && (SpriteList[x].sPosX < (8*40+Mick.PosAct)) )
                       		{
                       			NbSpr++;
                       			def_sprite( NbSpr,    SpriteList[x].sPosX -Mick.PosAct + Mick.PosX, SpriteList[x].sPosY, 0xf00, 0x4000 + (ADR_KILL / 32) ); 
      	                	}				
				break;
		}
	}	
	show_sprite(1,NbSpr);
}


/********** AnimFish ************/
/* Anim a Fish type object	*/
/* DestY is the UPPER point	*/
/* the fish can jump		*/
/********************************/
void AnimFish( myFish )
struct  ObjectStruct *myFish;
{
	/* make some bumper effect...the change Y = distance to jump/8  */
	int Dist;
	Dist = (myFish->sPosY - myFish->sDestY)>>5;
	myFish->sPosY+=( myFish->Dir + (myFish->Dir * Dist) );

	if ( (myFish->Dir == UP) && (myFish->sPosY <= myFish->sDestY) )			myFish->Dir = DOWN;
	if ( (myFish->Dir == DOWN) && (myFish->sPosY >= (28*8+myFish->Height)) )	myFish->Dir = UP;
	
	
	switch(myFish->Step>>1)
	{
		case 1:
		case 2:
			def_sprite(myFish->sNumSpr,    myFish->sPosX -Mick.PosAct + Mick.PosX, myFish->sPosY,    0xb00, 0x4000 + (ADR_FISH0A / 32) ); 
      	                def_sprite(myFish->sNumSpr+1,  myFish->sPosX -Mick.PosAct + Mick.PosX, myFish->sPosY+32, 0x800, 0x4000 + (ADR_FISH0B / 32) );
      	                break;
      	        case 3:
      	        case 4:
			def_sprite(myFish->sNumSpr,    myFish->sPosX -Mick.PosAct + Mick.PosX, myFish->sPosY,    0xb00, 0x4000 + (ADR_FISH1A / 32) ); 
      	                def_sprite(myFish->sNumSpr+1,  myFish->sPosX -Mick.PosAct + Mick.PosX, myFish->sPosY+32, 0x800, 0x4000 + (ADR_FISH1B / 32) );
      	                break;
	}

	myFish->Step++;
	if (myFish->Step == 10)	myFish->Step = 2;
	
}


/********* AnimMosqito **********/
/* Anim a Moquito type object	*/
/* DestX is the LEFTER point	*/
/* the mosquito can fly		*/
/********************************/
void AnimMosquito( myMosquito )
struct  ObjectStruct *myMosquito;
{
	myMosquito->sPosX+= SIGNDIR(myMosquito->Dir);
	
	if ( (myMosquito->Dir == LEFT) && (myMosquito->sPosX <= myMosquito->sDestX) )
	{
		myMosquito->Dir = RIGHT;
		myMosquito->sDestX += 10*8;
	}
	
	if ( (myMosquito->Dir == RIGHT) && (myMosquito->sPosX >= myMosquito->sDestX) )
	{
		myMosquito->Dir = LEFT;
		myMosquito->sDestX -= 10*8;
	}
	
	
	switch(myMosquito->Step)
	{
		case 1:
			def_sprite(myMosquito->sNumSpr,   myMosquito->sPosX - (Mick.PosAct+ Mick.PosX), myMosquito->sPosY,    0xe00, 0x4000 + (ADR_MOSQUITO0 / 32)  + (MOSQUITOFLIP(myMosquito->Dir) << 11) );
			break;
		case 2:
			def_sprite(myMosquito->sNumSpr,   myMosquito->sPosX - (Mick.PosAct+ Mick.PosX), myMosquito->sPosY,    0xe00, 0x4000 + (ADR_MOSQUITO1 / 32)  + (MOSQUITOFLIP(myMosquito->Dir) << 11) );
			break;
		case 3:
			def_sprite(myMosquito->sNumSpr,   myMosquito->sPosX - (Mick.PosAct+ Mick.PosX), myMosquito->sPosY,    0xe00, 0x4000 + (ADR_MOSQUITO2 / 32)  + (MOSQUITOFLIP(myMosquito->Dir) << 11) );
			break;			
	}
			
	
	myMosquito->Step++;
	if (myMosquito->Step==4)	myMosquito->Step = 1;
}



void SpritesContact(Hero)
struct HeroStruc *Hero;
{
	uint x;
	
	for(x=1; x<NbrObj;x++) /* 1 because Hero not needed */
	{
		if ( Sprite_Collide(Hero, &SpriteList[x]) )
		{
			switch (SpriteList[x].lType)
			{
				case OBJ_LIFE1:
				case OBJ_LIFE2:
					if (SpriteList[x].Step == VISIBLE)	Hero->Life -= SpriteList[x].Damage;
					SpriteList[x].Step = INVISIBLE;
					break;
				case OBJ_FISH:
				case OBJ_MOSQUITO:
					if (!Hero->DisableHurt)
					{
						Hero->Life -= SpriteList[x].Damage;
						if (Hero->Life <= 0)	
							InitDie_Hero(Hero);
						else
							Hero->DisableHurt = 1;
					}
					break;
				case OBJ_KILL:
					if (Hero->Action == JUMP && !Hero->DisableHurt)
					{
						Hero->Life = 0;
						InitDie_Hero(Hero);
					}
					break;
			}
			return; /*we assume 2 sprites collision is impossible so we gain time quitting now */
			/*x = NbrObj+10; quit loop */
		}
	}

}


uchar Sprite_Collide( Hero, Sprite )
struct HeroStruc *Hero;
struct  ObjectStruct *Sprite;
{	
	if ( (Hero->PosAct + (8*Hero->Width)) < (Sprite->sPosX) )	return 0;
	if ( (Hero->PosAct) > (Sprite->sPosX + (8*Sprite->Width)) ) 	return 0;
	if ( (Hero->PosY + (8*Hero->Height)) < (Sprite->sPosY) )	return 0;
	if ( (Hero->PosY) > (Sprite->sPosY + (8*Sprite->Height)) )	return 0;
	
	return 1;		
}