#ifndef _INC_SPRITES_

#define ADR_MOSQUITO0	( ADR_MICK2 + (32 * 4 * 4) + (32 * 4 *1) )
#define ADR_MOSQUITO1	( ADR_MOSQUITO0 + (32 * mosquito0_HSize * mosquito0_VSize) )
#define ADR_MOSQUITO2	( ADR_MOSQUITO1 + (32 * mosquito1_HSize * mosquito1_VSize) )
#define ADR_FISH0A	( ADR_MOSQUITO2 + (32 * mosquito2_HSize * mosquito2_VSize) )
#define ADR_FISH0B	( ADR_FISH0A + (32 * fish0a_HSize * fish0a_VSize) )
#define ADR_FISH1A	( ADR_FISH0B + (32 * fish0b_HSize * fish0b_VSize) )
#define ADR_FISH1B	( ADR_FISH1A + (32 * fish1a_HSize * fish1a_VSize) )
#define ADR_LIFE1	( ADR_FISH1B + (32 * fish1b_HSize * fish1b_VSize) )
#define ADR_KILL	( ADR_LIFE1 + (32 * life1_HSize * life1_VSize) )


/** Type of Object **/
#define OBJ_HERO	0x0010	/* Hero init pos */
#define OBJ_LIFE1	0x0020  /* Item + 20 life */
#define OBJ_LIFE2	0x0030  /* Item Full life */
#define OBJ_FISH	0x0100	/* Fish UPPER pos (since fish jump from 28 to UPPER pos) */
#define OBJ_MOSQUITO	0x0200	/* Mosquito RIGHT pos (since mosquito go from RIGHT to RIGHT - 10 tiles and RIGHT-10 to RIGHT, etc... */
#define OBJ_KILL	0x0300  /* Dangerous metal pic */

/** for the fish **/
#define UP              -1
#define DOWN            1


#define VISIBLE		1	/* a visible Life item can be take */
#define INVISIBLE	0	/* a invisible life item isn't draw and can't be take anymore */

#define IMPAIR(x)	( x&0x01?1:0 )	

/* GRR! i make my mosquito tile against the technique i create for the tile flipping of Hero */
#define MOSQUITOFLIP(x)	( x==LEFT?0:1)

/* Object graf */
extern uint pal_enemy[16];
/* MosquitoStep1*/
extern uint mosquito0_HSize;
extern uint mosquito0_VSize;
extern ulong mosquito0[];
/* MosquitoStep2*/
extern uint mosquito1_HSize;
extern uint mosquito1_VSize;
extern ulong mosquito1[];
/* MosquitoStep3*/
extern uint mosquito2_HSize;
extern uint mosquito2_VSize;
extern ulong mosquito2[];
/* FishStep1_a*/
extern uint fish0a_HSize;
extern uint fish0a_VSize;
extern ulong fish0a[];
/* FishStep1_b*/
extern uint fish0b_HSize;
extern uint fish0b_VSize;
extern ulong fish0b[];
/* FishStep2_a*/
extern uint fish1a_HSize;
extern uint fish1a_VSize;
extern ulong fish1a[];
/* FishStep2_b*/
extern uint fish1b_HSize;
extern uint fish1b_VSize;
extern ulong fish1b[];

/* Life1*/
extern uint life1_HSize;
extern uint life1_VSize;
extern ulong life1[];
/* Kill*/
extern uint kill_HSize;
extern uint kill_VSize;
extern ulong kill[];





/* Object Pos/Type def by MapMaker */
struct  MapMakerObjectStruct {
	int	sPosX;
	int   	sPosY;
	ulong   lFlags;
};

/* Object Pos/Type def as WE wish */
struct  ObjectStruct {
	ulong   lType;		/* what type of object ? */
	int	sPosX;		/* Cur x */
	int     sPosY;		/* Cur y */
	int	sDestX;		/* X we're going */
	int	sDestY;		/* Y we're going */
        char 	Dir;		/* Direction */
        uchar 	Action;		/* What we're doing */
        uchar 	Step;		/* What step */
	uint	Width;
	uint	Height;
	char	Damage;		/* Damage we do to Hero */
	char	Life;		/* my Energy */
	ulong	lSpecial;	/* Special feature for special use (ie just in case!) */
	uint 	sNumSpr;	/* which is the sprite number we reserved to it? */
};


extern uint NbrObj;
extern struct MapMakerObjectStruct ObjectList[];
struct ObjectStruct SpriteList[30];

/************** Function prototypes *************/
void RedrawActifSpr( part );
void LoadTile_Object();
void Init_Object();

/* init our sprites functions */
void Init_Fish( myFish, myFishPreDef, SprNum);
void Init_Mosquito( myMosquito, myMosquitoPreDef, SprNum);
/* anim our sprites functions */
void AnimFish( myFish );
void AnimMosquito( myMosquito );

void SpritesContact( Hero );
uchar Sprite_Collide( Hero, Sprite );


#define _INC_SPRITES_
#endif

